/*
  gcc `sdl2-config --cflags` draw_point.c -o draw_point `sdl2-config --libs`
*/

#include <stdlib.h>

#include <SDL2/SDL.h>

#define WINDOW_WIDTH 600

int main(int argc, char *argv[])
{
  SDL_Event event;
  SDL_Renderer *renderer;
  SDL_Window *window;
  int i;
  int quit = 0;
  const int ESC = 27;

  SDL_Init(SDL_INIT_VIDEO);

  /* SDL_CreateWindowAndRenderer(WINDOW_WIDTH, WINDOW_WIDTH, 0, &window, &renderer); */

  window = SDL_CreateWindow("SDL2 Demo Draw_Point",
                            SDL_WINDOWPOS_UNDEFINED,SDL_WINDOWPOS_UNDEFINED,
                            WINDOW_WIDTH,WINDOW_WIDTH,
                            SDL_WINDOW_SHOWN);

  renderer = SDL_CreateRenderer(window, -1, 0);


  SDL_SetRenderDrawColor(renderer, 0, 0, 0, 0);
  SDL_RenderClear(renderer);

  SDL_SetRenderDrawColor(renderer, 255, 0, 0, 255);
  for (i = 0; i < WINDOW_WIDTH; ++i)
    SDL_RenderDrawPoint(renderer, i, i);
  SDL_RenderPresent(renderer);
  while (!quit)
  {
    /* Poll for events */
    while( SDL_PollEvent( &event ) ){

      switch( event.type ){
        /* Keyboard event */
        /* Pass the event data onto PrintKeyInfo() */
      case SDL_KEYDOWN:
        printf("KEY = %d\n",event.key.keysym.sym);
        if (event.key.keysym.sym == ESC) quit = 1;
        break;

        /* SDL_QUIT event (window close) */
      case SDL_QUIT:
        quit = 1;
        break;

      default:
        break;
      }

    }
  }
  SDL_DestroyRenderer(renderer);
  SDL_DestroyWindow(window);
  SDL_Quit();
  return EXIT_SUCCESS;
}
