!
! gfortran -std=f2008 `sdl2-config --cflags` ../f03sdl2-master/sdl2.f90 \
!   draw_point.f90 -o draw_point-fortran `sdl2-config --libs`
!

program draw_point
  use, intrinsic :: iso_c_binding, only: c_null_char, c_ptr
  use sdl2_consts, only: SDL_KEY_DOWN, SDL_INIT_VIDEO, SDL_QUIT_TYPE, &
       SDL_WINDOWPOS_UNDEFINED, SDL_WINDOW_SHOWN
  use sdl2_types, only: sdl_event
  use sdl2, only: sdl_create_renderer, sdl_create_window, &
       sdl_destroy_renderer, sdl_destroy_window, sdl_init, &
       sdl_poll_event, sdl_quit, sdl_render_clear, sdl_render_draw_point, &
       sdl_render_present, sdl_set_render_draw_color

  implicit none

  type(sdl_event) :: event
  type(c_ptr) :: renderer
  type(c_ptr) :: window

  integer, parameter :: ESC = 27, WINDOW_WIDTH = 600
  integer :: i, quit, rc

  rc = sdl_init(SDL_INIT_VIDEO)

  window = sdl_create_window('SDL2 Fortran' // c_null_char, &
       SDL_WINDOWPOS_UNDEFINED,SDL_WINDOWPOS_UNDEFINED, &
       WINDOW_WIDTH,WINDOW_WIDTH, &
       SDL_WINDOW_SHOWN)

  renderer = sdl_create_renderer(window, -1, 0)

  rc = sdl_set_render_draw_color(renderer, &
       int(0,2),int(0,2),int(0,2),int(0,2))
  rc = sdl_render_clear(renderer)

  rc = sdl_set_render_draw_color(renderer, &
       int(255,2),int(0,2),int(0,2),int(255,2))

  do i = 0, WINDOW_WIDTH-1
     rc = sdl_render_draw_point(renderer,i,i)
  end do

  call sdl_render_present(renderer)

  do while (quit == 0)
     do while (sdl_poll_event(event) /= 0)
        select case (event%type)
        case (SDL_KEY_DOWN)
           write(*,'(A,i0)') 'KEY = ', event%key%key_sym%sym
           if (event%key%key_sym%sym == ESC) quit = 1

        case (SDL_QUIT_TYPE)
           quit = 1
        end select
     end do
  end do

  call sdl_destroy_renderer(renderer)
  call sdl_destroy_window(window)

  call sdl_quit()

end program draw_point
